Subject: Re: bug#32337: 26.1; display-line-numbers-mode makes cursor ill-aligned when number face is changed

From: Eli Zaretskii <[email-masked]>
Date: Sat, 04 Aug 2018 10:07:07 +0300

> Date: Sat, 04 Aug 2018 09:29:36 +0300
> From: Eli Zaretskii <[email-masked]>
> Cc: [email-masked], [email-masked]
> 
> > From: Carlos Pita <[email-masked]>
> > Date: Fri, 3 Aug 2018 20:14:29 -0300
> > Cc: [email-masked], [email-masked]
> > 
> > Eli, it ocurred to me that the line-number indicator could be extended all the way down to the bottom of the
> > window so it doesn't look weird when empty, since one of your objections was about having that hanging
> > empty last line indicator. What do you think about that option?
> 
> That looked weird (a.k.a. "bug-like") in my experiments, when the face
> defines colors.

Yes.

> Moreover, currently we draw nothing at all beyond EOB, we just clear
> the rest of the window.  So this would need special tricky code that
> will complicate the display engine, something I'd like to avoid.

No, that was backwards: whatever we decide to do for the first line
beyond EOB will automatically happen for all the other lines till the
end of the window.  Avoiding that, i.e. displaying the special
character or whatever only on the first line beyond EOB, is what would
take tricky code.

Still, I stand by my opinion: displaying a line-number field beyond
EOB with non-default background color looked ugly in my experiments,
which led me to the current implementation that uses the default
face.  That is the most important issue people need to consider when
they ask to revert that decision.  I would even urge people who want
that to modify Emacs locally to use the line-number face and run with
it for some time (using a non-default background color), to see
whether the results are satisfactory.